package com.upyuns.platform.rs.website.biz;

import cn.hutool.core.util.StrUtil;
import com.upyuns.platform.rs.gtdata.GtDataRestClient;
import com.upyuns.platform.rs.website.entity.FileData;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import com.upyuns.platform.rs.website.entity.GainData;
import com.upyuns.platform.rs.website.mapper.GainDataMapper;
import com.github.wxiaoqi.security.common.biz.BaseBiz;

import java.util.List;

import static com.github.wxiaoqi.security.common.constant.CommonConstants.SYS_FALSE;

/**
 * 成果数据
 *
 * @author zjw
 * @email jiaoruizhen@126.com
 * @date 2024-05-15 18:31:38
 */
@Service
public class GainDataBiz extends BaseBiz<GainDataMapper,GainData> {

    @Value("${universal.gaindataPath}")
    private String gaindataPath;

    @Autowired
    FileDataBiz fileDataBiz;

    @Autowired
    GtDataRestClient gtDataRestClient;


    public void dealGtdata(List<GainData> list) {
        for(GainData gainData: list) {
            String gtdataPath = gainData.getGtdataPath();
            //判断gtdata路径是否存在
            if(StrUtil.isBlank(gtdataPath)) {
                //根据id创建gtdata目录
                gtdataPath = "/rscloudmart"+ gaindataPath + "/" + gainData.getId();
                gtDataRestClient.mkdirs(gtdataPath);
//                gainData.setGtdataPath(gtdataPath);
                String finalGtdataPath = gtdataPath;
                updateSelectiveById(new GainData() {{
                    setId(gainData.getId());
                    setGtdataPath(finalGtdataPath);
                    setHasGtdata(HASGTDATA_FIN);
                }});
            }else {
                //判断路径是否存在
                //isExist(parentPath).get("exist").toString().equals("true")
                if(!gtDataRestClient.isExist(gtdataPath).get("exist").toString().equals("true")){
                    gtDataRestClient.mkdirs(gtdataPath);
                    updateSelectiveById(new GainData() {{
                        setId(gainData.getId());
                        setHasGtdata(HASGTDATA_FIN);
                    }});
                }
            }



            //查询包含的数据是否存在
            List<FileData> fileDataList = fileDataBiz.selectList(new FileData(){{
                setGainId(gainData.getId());
                setIsDel(SYS_FALSE);
                setHasGtdata(HASGTDATA_NOT);
            }});

            for(FileData fileData : fileDataList) {
                if(StrUtil.isBlank(fileData.getGtdataPath())) {
                    String fileGtdataPath = gtdataPath + "/" + fileData.getFilename();
                    FileData finalFileData = fileData;
                    fileDataBiz.updateSelectiveById(new FileData(){{
                        setId(finalFileData.getId());
                        setGtdataPath(fileGtdataPath);
                    }});
                    fileData = fileDataBiz.selectById(fileData.getId());
                }
                if(!gtDataRestClient.isExist(fileData.getGtdataPath()).get("exist").toString().equals("true")){
                    gtDataRestClient.createLarge(fileData.getFilepath(), fileData.getGtdataPath());
                }
                FileData finalFileData1 = fileData;
                fileDataBiz.updateSelectiveById(new FileData(){{
                    setId(finalFileData1.getId());
                    setHasGtdata(HASGTDATA_FIN);
                }});
            }
        }
    }
}